import { QueryOrderMap, FilterQuery } from '@mikro-orm/core';

declare class Cursor<T extends object> {
    private readonly state;
    private constructor();
    static fromEntity<T extends object>(entity: T, orderBy: QueryOrderMap<T> | QueryOrderMap<T>[]): Cursor<T>;
    static fromBase64<T extends object>(base64: string): Cursor<T>;
    toBase64(): string;
    toJSON(): string;
    orderBy({ direction }: {
        direction: 'forward' | 'backward';
    }): QueryOrderMap<T>;
    where({ direction }: {
        direction: 'forward' | 'backward';
    }): FilterQuery<T>[];
}

export { Cursor };
